/*
 * 小程序开发者关联
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProjectForDevelopController : BaseController
    {
        public ProjectForDevelopController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 小程序开发者关联列表

        /// <summary>
        /// 根据条件查询小程序开发者关联列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProjectForDevelop data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            
            return View();
        }

        #endregion

        #region 根据条件查询小程序开发者关联列表

        /// <summary>
        /// 小程序开发者关联列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProjectForDevelop data, string DeveloperIdRealName, string DeveloperIdNickName, string DeveloperIdMobile, string ProjectIdSelect, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            

            string condition = " and Status>-1";
            //开发者真实姓名
if (!string.IsNullOrEmpty(DeveloperIdRealName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForRealName where RealName='" + DeveloperIdRealName + "')";
}
//开发者昵称
if (!string.IsNullOrEmpty(DeveloperIdNickName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForNickName where NickName='" + DeveloperIdNickName + "')";
}
//开发者手机号
if (!string.IsNullOrEmpty(DeveloperIdMobile))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForMobile where Mobile='" + DeveloperIdMobile + "')";
}
//小程序
if (!string.IsNullOrEmpty(ProjectIdSelect))
{
condition += " and ProjectId=" + ProjectIdSelect;
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("ProjectForDevelop", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //开发者
int DeveloperId = int.Parse(function.CheckInt(dic["DeveloperId"].ToString()));
Developers developerid_Developers = db.Developers.FirstOrDefault(m => m.Id == DeveloperId) ?? new Developers();
dic["DeveloperIdRealName"] = developerid_Developers.RealName;
dic["DeveloperIdNickName"] = developerid_Developers.NickName;
dic["DeveloperIdMobile"] = developerid_Developers.Mobile;
dic.Remove("DeveloperId");
//小程序
// dic["ProjectId"] = RelationClass.GetProjectsInfo(int.Parse(dic["ProjectId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加小程序开发者关联

        /// <summary>
        /// 增加或修改小程序开发者关联信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加小程序开发者关联

        /// <summary>
        /// 增加或修改小程序开发者关联信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProjectForDevelop data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("DeveloperId", data.DeveloperId); //开发者
Fields.Add("ProjectId", data.ProjectId); //小程序

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Add("ProjectForDevelop", Fields, 0);
            AddSysLog(data.Id.ToString(), "ProjectForDevelop", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改小程序开发者关联

        /// <summary>
        /// 增加或修改小程序开发者关联信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            ProjectForDevelop editData = db.ProjectForDevelop.FirstOrDefault(m => m.Id == Id) ?? new ProjectForDevelop();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改小程序开发者关联

        /// <summary>
        /// 增加或修改小程序开发者关联信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProjectForDevelop data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("DeveloperId", data.DeveloperId); //开发者
Fields.Add("ProjectId", data.ProjectId); //小程序

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectForDevelop", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"ProjectForDevelop","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除小程序开发者关联信息

        /// <summary>
        /// 删除小程序开发者关联信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectForDevelop","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectForDevelop", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectForDevelop","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectForDevelop", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"ProjectForDevelop","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Edit("ProjectForDevelop", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).Sort("ProjectForDevelop", Sort, Id);
            
            AddSysLog(Id.ToString(), "ProjectForDevelop", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.ProjectForDevelop.Add(new ProjectForDevelop()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProjectForDevelop", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProjectForDevelop data, string DeveloperIdRealName, string DeveloperIdNickName, string DeveloperIdMobile, string ProjectIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            

            string condition = " and Status>-1";
            //开发者真实姓名
if (!string.IsNullOrEmpty(DeveloperIdRealName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForRealName where RealName='" + DeveloperIdRealName + "')";
}
//开发者昵称
if (!string.IsNullOrEmpty(DeveloperIdNickName))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForNickName where NickName='" + DeveloperIdNickName + "')";
}
//开发者手机号
if (!string.IsNullOrEmpty(DeveloperIdMobile))
{
condition += " and DeveloperId in (select DeveloperId from DevelopersForMobile where Mobile='" + DeveloperIdMobile + "')";
}
//小程序
if (!string.IsNullOrEmpty(ProjectIdSelect))
{
condition += " and ProjectId=" + ProjectIdSelect;
}


            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, SystemPublicFuction.dbtables).IndexData("ProjectForDevelop", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //开发者
int DeveloperId = int.Parse(function.CheckInt(dic["DeveloperId"].ToString()));
Developers developerid_Developers = db.Developers.FirstOrDefault(m => m.Id == DeveloperId) ?? new Developers();
dic["DeveloperIdRealName"] = developerid_Developers.RealName;
dic["DeveloperIdNickName"] = developerid_Developers.NickName;
dic["DeveloperIdMobile"] = developerid_Developers.Mobile;
dic.Remove("DeveloperId");
//小程序
// dic["ProjectId"] = RelationClass.GetProjectsInfo(int.Parse(dic["ProjectId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProjectForDevelop", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
